package org.lsis.bruno.inf21.rmi.hello.activable;

import java.io.IOException;
import java.rmi.MarshalledObject;
import java.rmi.RemoteException;
import java.rmi.activation.Activatable;
import java.rmi.activation.ActivationDesc;
import java.rmi.activation.ActivationException;
import java.rmi.activation.ActivationGroup;
import java.rmi.activation.ActivationGroupDesc;
import java.rmi.activation.ActivationGroupID;
import java.rmi.activation.ActivationSystem;
import java.rmi.registry.LocateRegistry;
import java.util.Properties;

import org.lsis.bruno.inf21.rmi.hello.Hello;
import org.lsis.bruno.inf21.rmi.hello.HelloImpl;

public class SetupActivHello {
	public static void main(String args[]) {
		//System.setSecurityManager(new SecurityManager());

		// groupe d'obj activables
		Properties props = new Properties();
		props.put("java.security.policy", "data/setup.policy");
		ActivationGroupDesc.CommandEnvironment ace = null;

		ActivationGroupDesc aGroupDesc = new ActivationGroupDesc(props, ace);
		try {
			ActivationSystem aSystem = ActivationGroup.getSystem();
			ActivationGroupID agi = aSystem.registerGroup(aGroupDesc);
			ActivationGroup.createGroup(agi, aGroupDesc, 0);

			ActivationDesc aDesc = new ActivationDesc(agi,
					"org.lsis.bruno.inf21.rmi.hello.activable.HelloActivatableImpl",
					"http://pc-bruno/~bruno/", new MarshalledObject<Hello>(
							new HelloImpl(100)));

			Hello obj = (Hello) Activatable.register(aDesc);
	        LocateRegistry.getRegistry().rebind("HelloActiv", obj);
			
			System.exit(0);

		} catch (ActivationException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
