package org.lsis.bruno.inf21.rmi.hello.asynchrone;

import java.net.MalformedURLException;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import org.lsis.bruno.inf21.rmi.hello.Hello;
import org.lsis.bruno.inf21.rmi.hello.personne.Person;
import org.lsis.bruno.inf21.rmi.hello.personne.PersonImpl;

public class AsyncHelloClient {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			Hello h = (Hello) java.rmi.Naming.lookup("//" + args[0]
					+ "/HelloObject");
			Person person = new PersonImpl("Pierre", "Durand");
			System.err.println(person);
			UnicastRemoteObject.exportObject(person);
			System.err.println(h.sayHello(person));
			//person = null; //force local and global GC
			UnicastRemoteObject.unexportObject(person, false);
			System.err.println(person);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (NotBoundException e) {
			e.printStackTrace();
		}
	}
}
