package org.lsis.bruno.inf21.rmi.hello.java5;

import java.rmi.RemoteException;

public class HelloImpl implements Hello {
	private int defaultlang;

	public HelloImpl(int defaultlang) throws java.rmi.RemoteException {
		super();
		this.defaultlang = defaultlang;
	}

	@Override
	public String sayHello() throws RemoteException {
		return sayHello(null, defaultlang);
	}

	@Override
	public String sayHello(String name) throws RemoteException {
		return sayHello(name, defaultlang);
	}

	@Override
	public String sayHello(String name, int lang) throws RemoteException {
		switch (lang) {
		case Hello.EN:
			break;
		case Hello.FR:
			break;
		case Hello.ES:
			break;
		default:
			lang = Hello.EN;
		}

		switch (lang) {
		case Hello.EN:
			return "Hello " + ((name == null) ? "World" : name);
		case Hello.FR:
			return "Bonjour " + ((name == null) ? "tout le monde" : name);
		case Hello.ES:
			return "Hola " + ((name == null) ? "todo el mundo" : name);
		default:
			return null;
		}
	}
}
